// BmpBtn.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "AXCPI01App.h"
#include "BmpBtn.h"
#include "typedef.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CBmpBtn

//***********************************************************************
//	֐F׽̍\z
//	֐@FCBmpBtn
//***********************************************************************
CBmpBtn::CBmpBtn()
	: m_ShowFocus(TRUE)
{
	m_pDoc	= NULL;
}

//***********************************************************************
//	֐F׽̔j
//	֐@F~CBmpBtn
//***********************************************************************
CBmpBtn::~CBmpBtn()
{
}


BEGIN_MESSAGE_MAP(CBmpBtn, COwnerBtn)
	//{{AFX_MSG_MAP(CBmpBtn)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBmpBtn bZ[W nh

//***********************************************************************
//	֐Fĕ`
//	֐@FInvalidate
//***********************************************************************
void CBmpBtn::Invalidate()
{
	if (m_hWnd)
		COwnerBtn::Invalidate(FALSE);			//ĕ`
}

//***********************************************************************
//	֐F݂̫L׸ނ
//	֐@FShowFocus
//		F  BOOL	tf		̫׸
//***********************************************************************
void CBmpBtn::ShowFocus(BOOL tf)
{
	m_ShowFocus = tf;				//̫׸޾
	Invalidate();					//ĕ`
}

// virtual
//***********************************************************************
//	֐F݂÷Ă\
//	֐@FonDisplayText
//		F	CDC*				pDC		޲÷
//				const CRect			rrc		̈
//				LPDRAWITEMSTRUCT	lpDIS	ݏ
//***********************************************************************
void CBmpBtn::onDisplayText(CDC* pDC, const CRect& rrc, LPDRAWITEMSTRUCT lpDIS)
{
	CRect	rc(rrc);
	CString txt;
	GetWindowText(txt);
	if (!txt.IsEmpty()) 
	{	//÷ĂNULLłȂꍇ
		// ߃[hɂāc
		pDC->SetBkMode(TRANSPARENT);
		// ̕KvƂ̈vZ
		CRect drc(rc);
//		pDC->DrawText(txt, &drc, DT_SINGLELINE | DT_CALCRECT);
		pDC->ExtTextOut(0,0,ETO_CLIPPED,&drc,(LPCTSTR)txt,txt.GetLength(),NULL);
	}
}

//////////////////////////////////////////////////////////
// I[i[h[̃nh
//***********************************************************************
//	֐FŰ۰
//	֐@FDrawItem
//		F	LPDRAWITEMSTRUCT	lpDIS	ݏ
//***********************************************************************
void CBmpBtn::DrawItem(LPDRAWITEMSTRUCT lpDIS) 
{
	// TODO: w肳ꂽACe`悷邽߂̃R[hǉĂ
	
	// DC̃nhCDCNX̃IuWFNg쐬
	CDC* pDC = CDC::FromHandle(lpDIS->hDC);
	// DC̑Sۑ
	pDC->SaveDC();
	// `悷ׂ̈
	CRect rc = lpDIS->rcItem;

	int		nBitsPixel = pDC->GetDeviceCaps(BITSPIXEL);

	if (lpDIS->itemAction & (ODA_DRAWENTIRE | ODA_SELECT)) 
	{	// {^{̂̕`悪Kvł
		// DrawFrameControl()Ăяoۂ̃tO
		UINT flag = /*DFCS_ADJUSTRECT | */DFCS_BUTTONPUSH;

		// vbV{^̏ꍇAODA_SELECT̓vbVĂ邱ƂӖ
		if (lpDIS->itemState & ODS_SELECTED) 
		{
			// ݉Ă
			flag |= DFCS_PUSHED;
		}

		if(nBitsPixel <= 8)	
		{	// ghԂ
			CBrush brush(RGB(0,0,160));
			pDC->FillRect(rc, &brush);
		}
		else if(lpDIS->CtlID == IDC_TITLE1_BUTTON)
		{
			CBrush brush(::GetSysColor(COLOR_3DFACE));
			pDC->FillRect(rc, &brush);
		}
		else if(lpDIS->CtlID == IDC_TITLE2_BUTTON)
		{
			CBrush brush(::GetSysColor(COLOR_3DFACE));
			pDC->FillRect(rc, &brush);
		}
		else 
		{	// {^a̕`
			DrawButtonBmp(pDC,&rc,lpDIS);
		}

		m_InnerRc = rc;

		// {^̕`
		onDisplayText(pDC, rc, lpDIS);
	}

	if (m_ShowFocus && ((lpDIS->itemAction & ODA_FOCUS) || (lpDIS->itemState & ODS_FOCUS)))
	{
		// IF̍ĕ`
		onDisplayText(pDC, rc, lpDIS);

		// tH[JX_`
//		CRect frc = m_InnerRc;	// focus rect
//		frc.DeflateRect(::GetSystemMetrics(SM_CXBORDER),
//			::GetSystemMetrics(SM_CYBORDER));
//		pDC->DrawFocusRect(frc);
	}
	pDC->RestoreDC(-1);
}


//***********************************************************************
//	֐F݂ޯϯ߂\t
//	֐@FDrawButtonBmp
//		F	CDC*				pDC		޲÷
//				const CRect			rrc		̈
//				LPDRAWITEMSTRUCT	lpDIS	ݏ
//***********************************************************************
void CBmpBtn::DrawButtonBmp(CDC *pDC,CRect *pRect,LPDRAWITEMSTRUCT lpDIS)
{
	WORD	wBmpID	= 0;
	WORD	wCtrlID	= lpDIS->CtlID;

	if(wCtrlID == IDC_HELP_BUTTON)
	{
		wBmpID = IDB_HELP;
	}
	else if(wCtrlID == IDC_CLEAR_BUTTON)
	{
		wBmpID = IDB_CLEAR;
	}
	else if(m_pDoc == NULL)
	{
		wBmpID = IDB_LEDOFF;
	}
	else
	{
		WORD	wPIOMode	= m_pDoc->GetPIOMode();
		WORD	wPIOOutMode	= m_pDoc->GetPIOOutMode();
		WORD	wPIOOutData	= m_pDoc->GetPIOOutData();
		WORD	wPIOInData	= m_pDoc->GetPIOInData();

		switch(wCtrlID)	
		{
			case	IDC_D0_BUTTON:
				if(wPIOMode & 0x0001)
				{	// INPUT
					if(wPIOInData & 0x0001)
						wBmpID = IDB_LEDON;
					else
						wBmpID = IDB_LEDOFF;
				}
				else if(wPIOOutMode & 0x0001)
				{	// Push/Pull Output
					if(wPIOOutData & 0x0001)
						wBmpID = IDB_SWON;
					else
						wBmpID = IDB_SWOFF;
				}
				else
				{	// OpenDrain Output
					if(wPIOOutData & 0x0001)
						wBmpID = IDB_SWONZ;
					else
						wBmpID = IDB_SWOFFZ;
				}
				break;
			case	IDC_D1_BUTTON:
				if(wPIOMode & 0x0002)
				{	// INPUT
					if(wPIOInData & 0x0002)
						wBmpID = IDB_LEDON;
					else
						wBmpID = IDB_LEDOFF;
				}
				else if(wPIOOutMode & 0x0002)
				{	// Push/Pull Output
					if(wPIOOutData & 0x0002)
						wBmpID = IDB_SWON;
					else
						wBmpID = IDB_SWOFF;
				}
				else
				{	// OpenDrain Output
					if(wPIOOutData & 0x0002)
						wBmpID = IDB_SWONZ;
					else
						wBmpID = IDB_SWOFFZ;
				}
				break;
			case	IDC_D2_BUTTON:
				if(wPIOMode & 0x0004)
				{	// INPUT
					if(wPIOInData & 0x0004)
						wBmpID = IDB_LEDON;
					else
						wBmpID = IDB_LEDOFF;
				}
				else if(wPIOOutMode & 0x0004)
				{	// Push/Pull Output
					if(wPIOOutData & 0x0004)
						wBmpID = IDB_SWON;
					else
						wBmpID = IDB_SWOFF;
				}
				else
				{	// OpenDrain Output
					if(wPIOOutData & 0x0004)
						wBmpID = IDB_SWONZ;
					else
						wBmpID = IDB_SWOFFZ;
				}
				break;
			case	IDC_D3_BUTTON:
				if(wPIOMode & 0x0008)
				{	// INPUT
					if(wPIOInData & 0x0008)
						wBmpID = IDB_LEDON;
					else
						wBmpID = IDB_LEDOFF;
				}
				else if(wPIOOutMode & 0x0008)
				{	// Push/Pull Output
					if(wPIOOutData & 0x0008)
						wBmpID = IDB_SWON;
					else
						wBmpID = IDB_SWOFF;
				}
				else
				{	// OpenDrain Output
					if(wPIOOutData & 0x0008)
						wBmpID = IDB_SWONZ;
					else
						wBmpID = IDB_SWOFFZ;
				}
				break;
			case	IDC_D4_BUTTON:
				if(wPIOMode & 0x0010)
				{	// INPUT
					if(wPIOInData & 0x0010)
						wBmpID = IDB_LEDON;
					else
						wBmpID = IDB_LEDOFF;
				}
				else if(wPIOOutMode & 0x0010)
				{	// Push/Pull Output
					if(wPIOOutData & 0x0010)
						wBmpID = IDB_SWON;
					else
						wBmpID = IDB_SWOFF;
				}
				else
				{	// OpenDrain Output
					if(wPIOOutData & 0x0010)
						wBmpID = IDB_SWONZ;
					else
						wBmpID = IDB_SWOFFZ;
				}
				break;
			case	IDC_D5_BUTTON:
				if(wPIOMode & 0x0020)
				{	// INPUT
					if(wPIOInData & 0x0020)
						wBmpID = IDB_LEDON;
					else
						wBmpID = IDB_LEDOFF;
				}
				else if(wPIOOutMode & 0x0020)
				{	// Push/Pull Output
					if(wPIOOutData & 0x0020)
						wBmpID = IDB_SWON;
					else
						wBmpID = IDB_SWOFF;
				}
				else
				{	// OpenDrain Output
					if(wPIOOutData & 0x0020)
						wBmpID = IDB_SWONZ;
					else
						wBmpID = IDB_SWOFFZ;
				}
				break;
			case	IDC_D6_BUTTON:
				if(wPIOMode & 0x0040)
				{	// INPUT
					if(wPIOInData & 0x0040)
						wBmpID = IDB_LEDON;
					else
						wBmpID = IDB_LEDOFF;
				}
				else if(wPIOOutMode & 0x0040)
				{	// Push/Pull Output
					if(wPIOOutData & 0x0040)
						wBmpID = IDB_SWON;
					else
						wBmpID = IDB_SWOFF;
				}
				else
				{	// OpenDrain Output
					if(wPIOOutData & 0x0040)
						wBmpID = IDB_SWONZ;
					else
						wBmpID = IDB_SWOFFZ;
				}
				break;
			case	IDC_D7_BUTTON:
				if(wPIOMode & 0x0080)
				{	// INPUT
					if(wPIOInData & 0x0080)
						wBmpID = IDB_LEDON;
					else
						wBmpID = IDB_LEDOFF;
				}
				else if(wPIOOutMode & 0x0080)
				{	// Push/Pull Output
					if(wPIOOutData & 0x0080)
						wBmpID = IDB_SWON;
					else
						wBmpID = IDB_SWOFF;
				}
				else
				{	// OpenDrain Output
					if(wPIOOutData & 0x0080)
						wBmpID = IDB_SWONZ;
					else
						wBmpID = IDB_SWOFFZ;
				}
				break;
			case	IDC_D8_BUTTON:
				if(wPIOMode & 0x0100)
				{	// INPUT
					if(wPIOInData & 0x0100)
						wBmpID = IDB_LEDON;
					else
						wBmpID = IDB_LEDOFF;
				}
				else if(wPIOOutMode & 0x0100)
				{	// Push/Pull Output
					if(wPIOOutData & 0x0100)
						wBmpID = IDB_SWON;
					else
						wBmpID = IDB_SWOFF;
				}
				else
				{	// OpenDrain Output
					if(wPIOOutData & 0x0100)
						wBmpID = IDB_SWONZ;
					else
						wBmpID = IDB_SWOFFZ;
				}
				break;
			case	IDC_D9_BUTTON:
				if(wPIOMode & 0x0200)
				{	// INPUT
					if(wPIOInData & 0x0200)
						wBmpID = IDB_LEDON;
					else
						wBmpID = IDB_LEDOFF;
				}
				else if(wPIOOutMode & 0x0200)
				{	// Push/Pull Output
					if(wPIOOutData & 0x0200)
						wBmpID = IDB_SWON;
					else
						wBmpID = IDB_SWOFF;
				}
				else
				{	// OpenDrain Output
					if(wPIOOutData & 0x0200)
						wBmpID = IDB_SWONZ;
					else
						wBmpID = IDB_SWOFFZ;
				}
				break;
			case	IDC_D10_BUTTON:
				if(wPIOMode & 0x0400)
				{	// INPUT
					if(wPIOInData & 0x0400)
						wBmpID = IDB_LEDON;
					else
						wBmpID = IDB_LEDOFF;
				}
				else if(wPIOOutMode & 0x0400)
				{	// Push/Pull Output
					if(wPIOOutData & 0x0400)
						wBmpID = IDB_SWON;
					else
						wBmpID = IDB_SWOFF;
				}
				else
				{	// OpenDrain Output
					if(wPIOOutData & 0x0400)
						wBmpID = IDB_SWONZ;
					else
						wBmpID = IDB_SWOFFZ;
				}
				break;
			case	IDC_D11_BUTTON:
				if(wPIOMode & 0x0800)
				{	// INPUT
					if(wPIOInData & 0x0800)
						wBmpID = IDB_LEDON;
					else
						wBmpID = IDB_LEDOFF;
				}
				else if(wPIOOutMode & 0x0800)
				{	// Push/Pull Output
					if(wPIOOutData & 0x0800)
						wBmpID = IDB_SWON;
					else
						wBmpID = IDB_SWOFF;
				}
				else
				{	// OpenDrain Output
					if(wPIOOutData & 0x0800)
						wBmpID = IDB_SWONZ;
					else
						wBmpID = IDB_SWOFFZ;
				}
				break;
			case	IDC_D12_BUTTON:
				if(wPIOMode & 0x1000)
				{	// INPUT
					if(wPIOInData & 0x1000)
						wBmpID = IDB_LEDON;
					else
						wBmpID = IDB_LEDOFF;
				}
				else if(wPIOOutMode & 0x1000)
				{	// Push/Pull Output
					if(wPIOOutData & 0x1000)
						wBmpID = IDB_SWON;
					else
						wBmpID = IDB_SWOFF;
				}
				else
				{	// OpenDrain Output
					if(wPIOOutData & 0x1000)
						wBmpID = IDB_SWONZ;
					else
						wBmpID = IDB_SWOFFZ;
				}
				break;
			case	IDC_D13_BUTTON:
				if(wPIOMode & 0x2000)
				{	// INPUT
					if(wPIOInData & 0x2000)
						wBmpID = IDB_LEDON;
					else
						wBmpID = IDB_LEDOFF;
				}
				else if(wPIOOutMode & 0x2000)
				{	// Push/Pull Output
					if(wPIOOutData & 0x2000)
						wBmpID = IDB_SWON;
					else
						wBmpID = IDB_SWOFF;
				}
				else
				{	// OpenDrain Output
					if(wPIOOutData & 0x2000)
						wBmpID = IDB_SWONZ;
					else
						wBmpID = IDB_SWOFFZ;
				}
				break;
		}
	}

	CDC		dcMem;
	BITMAP	bm;
	CBitmap bitmap;
	bitmap.LoadBitmap(wBmpID);												//ޯϯߓǂݍ

	bitmap.GetObject(sizeof(BITMAP), &bm);
	dcMem.CreateCompatibleDC(pDC);											//޲÷Ă̍쐬
	CBitmap*	pOldBitmap = dcMem.SelectObject(&bitmap);					//޼ުđI

	pDC->BitBlt(pRect->left, pRect->top, pRect->Width(), pRect->Height(), &dcMem, 
					0, 0, SRCCOPY);											//ޯϯߓ\t
//	pDC->StretchBlt(pRect->left, pRect->top, pRect->Width(), pRect->Height(), &dcMem, 
//					0, 0, bm.bmWidth, bm.bmHeight, SRCCOPY);				//ޯϯߓ\t

	dcMem.SelectObject(pOldBitmap);											//޼ުĂ̑I
	dcMem.DeleteDC();														//޲÷Ẳ

}

//***********************************************************************
//	֐FװگĂ̍쐬
//	֐@FShowFocus
//		F	CPalette *	pBitmapPal	گď
//				LPSTR 		lpBit		BITMAPINFOHEADER\
//	߂l	F	(TRUE)A(FALSE)s
//***********************************************************************
BOOL CBmpBtn::MakePalette(CPalette *pBitmapPal, LPSTR lpBit)
{
	//DIB̃J[̎擾
	int	wNumColors;

	WORD wBitCount = ((LPBITMAPINFOHEADER)lpBit)->biBitCount;			//ޯĶĎ擾
	switch(wBitCount) {													//F
		case 1:		wNumColors = 2;		break;
		case 4:		wNumColors = 16;	break;
		case 8:		wNumColors = 256;	break;
		default:	wNumColors = 0;		break;
	}

//
	LPLOGPALETTE	lpPal;
	HANDLE			hLogPal;
	HPALETTE		hpal = NULL;

	hLogPal = ::GlobalAlloc(GHND, sizeof(LOGPALETTE)+sizeof(PALETTEENTRY)*wNumColors);	//؂̊蓖

	if(hLogPal == NULL)
		return	FALSE;

	lpPal = (LPLOGPALETTE) GlobalLock((HGLOBAL)hLogPal);							//ؗ̈m

	lpPal->palVersion = 0x300;
	lpPal->palNumEntries = (WORD)wNumColors;
	for(int i=0;i<(int)wNumColors;i++) {
		lpPal->palPalEntry[i].peRed		= ((LPBITMAPINFO)lpBit)->bmiColors[i].rgbRed;
		lpPal->palPalEntry[i].peGreen	= ((LPBITMAPINFO)lpBit)->bmiColors[i].rgbGreen;
		lpPal->palPalEntry[i].peBlue	= ((LPBITMAPINFO)lpBit)->bmiColors[i].rgbBlue;
		lpPal->palPalEntry[i].peFlags	= 0;
	}

	BOOL bCreate = pBitmapPal->CreatePalette(lpPal);								//װگč쐬

	GlobalUnlock((HGLOBAL)hLogPal);													//؂̱ۯ
	GlobalFree((HGLOBAL)hLogPal);													//؂̉

	return bCreate;
}


//***********************************************************************
//	֐FhLgNXւ̃|C^̓o^
//	֐@FSetDocument
//		F	CAXCPI01Doc *	pDoc	CAXCPI01DocihLgjNX̃|C^
//***********************************************************************
void CBmpBtn::SetDocument(CAXCPI01Doc* pDoc)
{
	m_pDoc	= pDoc;
}


