/*
	AxcpiLib.h
	
	Class for ADTEK SYSTEM SCIENCE Axcpi01.dll utility.
	
*/

#if !defined(_AXCPI_LIB_INC_)
#define	_AXCPI_LIB_INC_


// Windows Message Base defined
#define AXCPI01_WM_OFS_CARD_REMOVAL		0
#define AXCPI01_WM_OFS_IN				1

#define	AXCPI01_WM_USER					WM_USER+0x2000
#define AXCPI01_WM_CARD_REMOVAL			AXCPI01_WM_USER+AXCPI01_WM_OFS_CARD_REMOVAL						
#define AXCPI01_WM_IN					AXCPI01_WM_USER+AXCPI01_WM_OFS_IN						

// 2007.03.03 : ADD -->
#define	AXCPI01_WM_SUSPEND				AXCPI01_WM_USER+AXCPI01_WM_OFS_SUSPEND		// POWER DOWN
#define	AXCPI01_WM_RESUME				AXCPI01_WM_USER+AXCPI01_WM_OFS_RESUME		// POWER ON
// <-- 2007.03.03 : ADD


class CAxcpiLib
{
public:
// RXgN^
	CAxcpiLib();

// fXgN^
	~CAxcpiLib();

	BOOL	Create(void);

	BOOL 	UtyAxcpi01GetVersion(PDWORD pdwDllVersion,PDWORD pdwDrvVersion);
	BOOL 	UtyAxcpi01Create(HWND hWnd,UINT uWMBase,PVOID pvInitArg);
	BOOL 	UtyAxcpi01Close(void);
	BOOL 	UtyAxcpi01GetResource(PDWORD pdwIOPortBase,PDWORD pdwIOPortLength);
	BOOL 	UtyAxcpi01InPortB(DWORD dwPort,PBYTE pbyValue);
	BOOL 	UtyAxcpi01OutPortB(DWORD dwPort,BYTE byValue);
	BOOL 	UtyAxcpi01InPortW(DWORD dwPort,PWORD pwValue);
	BOOL 	UtyAxcpi01OutPortW(DWORD dwPort,WORD wValue);
	DWORD 	UtyAxcpi01GetLastError(void);


protected:
	WORD 		m_wLogSocket;		// Logical Socket No.
};

#endif
