Option Strict Off
Option Explicit On
Module Sample
	'*****************************************************************************
	'* Axcpi01s.vb
	'*
	'* AXP-PI01Tv\[X
	'*
	'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
	'*
	'* Date Jun.2007
	'*
	'* ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
	'*
	'*****************************************************************************
	
	Private Const szAXCPI01 As String = "AXC-PI01"
	
	Public Sub Main()
		
		Dim strbuf As String
		Dim dwDllVer As Integer ' DLLo[W
		Dim dwDrvVer As Integer ' hCoo[W
		Dim wLogSocket As Short ' _\Pbgԍ
		Dim dwIOPortBase As Integer ' I/O|[gJnAhX
		Dim dwIOPortLength As Integer ' I/O|[g
		Dim IRQStatus As Byte ' 荞݃Xe[^X
		Dim Value As Byte
		
		'=========================================================================
		' Axcpi01.dll ̎gp錾
		'=========================================================================
		If Axcpi01wDllOpen() = False Then
			ErrorMessage((AXCPI01_SOCKET_AUTO))
			Exit Sub ' Axcpi01.dll ̃[hɎs܂
		End If
		
		'=========================================================================
		' o[W̎擾
		'=========================================================================
		If Axcpi01wGetVersion(dwDllVer, dwDrvVer) = False Then
			ErrorMessage((AXCPI01_SOCKET_AUTO))
			Exit Sub
		End If
		strbuf = "ްޮݏ" & Chr(10) & Chr(10) & "DLL Version:    &H" & Hex(dwDllVer) & Chr(10) & "Driver Version: &H" & Hex(dwDrvVer)
		ResultMessage((strbuf))
		
		'=========================================================================
		' AXC-PI01 ̎gp錾
		'=========================================================================
		wLogSocket = AXCPI01_SOCKET_AUTO ' gp̃foCX
		
		If Axcpi01wCreate(wLogSocket, 0, &H6401s, 0) = False Then ' foCX܂B
			ErrorMessage((AXCPI01_SOCKET_AUTO))
			Exit Sub
		End If
		
		strbuf = "޲" & Chr(10) & Chr(10) & "LogSocket: " & CStr(wLogSocket)
		
		ResultMessage((strbuf))
		
		
		'=========================================================================
		' \[X擾
		'=========================================================================
		If Axcpi01wGetResource(wLogSocket, dwIOPortBase, dwIOPortLength) = False Then
			ErrorMessage((wLogSocket))
			Exit Sub
		End If
		
		strbuf = "ؿ" & Chr(10) & Chr(10) & "IO Address: &H" & Hex(dwIOPortBase) & "-&H" & Hex(dwIOPortBase + dwIOPortLength - 1)
		ResultMessage((strbuf))
		
		'=========================================================================
		' eWX^̐ݒ
		' (WX^̏ڍׂɂẮAn[hEFÃ}jAQƂB)
		'=========================================================================
		' D0`D7rbgo͂ɐݒ肵A
		' D8`D13rbg͂ɐݒ肷
		' uI/O Select RegistervɃf[^uFF00hv[ho͂
		If Axcpi01wOutPortW(wLogSocket, AXCPI01_PORT_IO_SELECT_L, &HFF00s) = False Then
			ErrorMessage((wLogSocket))
			Exit Sub
		End If
		
		strbuf = "uI/O Select Registerv" & Chr(10) & " &HFF00 ܰޏo͂܂B" & Chr(10) & Chr(10) & "D0`D7   : o" & Chr(10) & "D8`D13 : "
		ResultMessage((strbuf))
		
		
		' D0rbgOpenDraino͂ɐݒ肷
		' uPU/PD Select RegistervɃf[^uFEhv޲ďo͂
		If Axcpi01wOutPortB(wLogSocket, AXCPI01_PORT_OUTPUT_MODE_L, &HFEs) = False Then
			ErrorMessage((wLogSocket))
			Exit Sub
		End If
		
		strbuf = "uOutput Mode Registerv" & Chr(10) & " &HFE ޲ďo͂܂B" & Chr(10) & Chr(10) & "D0 : OpenDraino"
		ResultMessage((strbuf))
		
		' D0rbgPull Downɐݒ肷
		' uPU/PD Select RegistervɃf[^uFDhvoCgo͂
		If Axcpi01wOutPortB(wLogSocket, AXCPI01_PORT_PUPD_SELECT_L, &HFDs) = False Then
			ErrorMessage((wLogSocket))
			Exit Sub
		End If
		
		strbuf = "uPU/PD Select Registerv" & Chr(10) & " &HFD ޲ďo͂܂B" & Chr(10) & Chr(10) & "D1 : Pull Down"
		ResultMessage((strbuf))
		
		'uData RegistervD0`D7rbgɁuAAHvoCgo͂
		If Axcpi01wOutPortB(wLogSocket, AXCPI01_PORT_DATA_L, &HAAs) = False Then
			ErrorMessage((wLogSocket))
			Exit Sub
		End If
		
		strbuf = "uData Registerv" & Chr(10) & "D0`D7ޯĂ" & Chr(10) & " &HAA ܰޏo͂܂B" & Chr(10) & Chr(10) & "D0`D7o : &HAA"
		ResultMessage((strbuf))
		
		'uData RegistervD8`D13rbgoCg͂
		If Axcpi01wInPortB(wLogSocket, AXCPI01_PORT_DATA_H, Value) = False Then
			ErrorMessage((wLogSocket))
			Exit Sub
		End If
		
		' ͂l\
		strbuf = "uData Registerv" & Chr(10) & "D8`D13ޯĂ" & Chr(10) & " ޲ē͂܂B" & Chr(10) & Chr(10) & "D8`D13 : &H" & Hex(Value)
		ResultMessage((strbuf))
		
		' 荞݋ݒ
		' uIRQ Registerv̉ʃoCgɃf[^u0EhvoCgo͂
		If Axcpi01wOutPortB(wLogSocket, AXCPI01_PORT_IRQ_L, &HEs) = False Then
			ErrorMessage((wLogSocket))
			Exit Sub
		End If
		
		strbuf = "uIRQ Registerv" & Chr(10) & " &H0E ޲ďo͂܂B" & Chr(10) & Chr(10) & "IRQ1: 荞݋"
		ResultMessage((strbuf))
		
		'=========================================================================
		' IRQ1荞ݔ҂
		'=========================================================================
		Do 
			' 荞݃Xe[^X擾
			If Axcpi01wGetIRQStatus(wLogSocket, IRQStatus) = False Then
				ErrorMessage((wLogSocket))
				Exit Do
			End If
			
			' IRQ1荞݂Ă
			If IRQStatus = &H1s Then
				strbuf = "IRQ1荞݂܂B" & Chr(10)
				ResultMessage((strbuf))
				Exit Do
			End If
			
		Loop 
		
		'=========================================================================
		' AXP-AXCPI01 J
		'=========================================================================
		If Axcpi01wClose(wLogSocket) = False Then
			ErrorMessage((wLogSocket))
			Exit Sub
		End If
		
		strbuf = "޲۰" & Chr(10) & Chr(10) & "LogSocket: " & CStr(wLogSocket)
		
		ResultMessage((strbuf))
		
		'=========================================================================
		' Axcpi01.dll J
		'=========================================================================
		If Axcpi01wDllClose() = False Then
			ErrorMessage((AXCPI01_SOCKET_AUTO))
			Exit Sub
		End If
		
	End Sub
	
	' ʂ\
	Private Sub ResultMessage(ByRef lpszbuf As String)
		
		MsgBox(lpszbuf, MsgBoxStyle.OKOnly + MsgBoxStyle.Information, "AXC-PI01")
	End Sub
	
	
	' G[bZ[W\
	Private Sub ErrorMessage(ByRef wLogSlot As Short)
		
		Dim dwRes As Integer
		Dim szbuf As String
		
		dwRes = Axcpi01wGetLastError(wLogSlot)
		
		Select Case dwRes
			Case AXCPI01_ERR_WRAPDLL
				szbuf = "DLL Load error"
				
			Case Else ' ̑̒l̏ꍇB
				szbuf = "AXC-PI01 error" & Chr(10) & Chr(10) & "Error code: &H" & Hex(dwRes)
		End Select
		
		MsgBox(szbuf, MsgBoxStyle.OKOnly + MsgBoxStyle.Critical, "AXC-PI01")
		
	End Sub
End Module