/*****************************************************************************
 * Axcpi01.h
 *
 * AXC-PI01 WinCE API
 * Copyright(C)ADTEK SYSTEM SCIENCE Co.,Ltd
 *
 * Date Jun.2007
/****************************************************************************/

#ifndef _AxcPi01_H_
#define _AxcPi01_H_

#ifdef __cplusplus
extern "C" {
#endif

/*-----------------------------------------------------------------
// G[R[h
//---------------------------------------------------------------*/
#define AXCPI01_SUCCESS					0	/* ُȂiIj*/
#define AXCPI01_ERR_SYSTEM				1	/* Windows  GetLastError() R[Ă */
#define AXCPI01_ERR_NO_DEVICE			2	/* gp\ȃfoCX܂ */
#define AXCPI01_ERR_IN_USE				3	/* w̃foCX͎gpł */
#define AXCPI01_ERR_INVALID_SOCKET		4	/* Ș_\Pbgł */
#define AXCPI01_ERR_RESOURCE			5	/* \[XG[ */
#define AXCPI01_ERR_INVALID_PORT		6	/* sȃ|[gv */
#define AXCPI01_ERR_INVALID_ARGUMENT	7	/* sȈv܂ */

/*-----------------------------------------------------------------
// ̑̒萔
//---------------------------------------------------------------*/
#define AXCPI01_MAX_SOCKETS				16
#define AXCPI01_SOCKET_AUTO				((WORD)~0U)

/*-----------------------------------------------------------------
// hCo瑗Ă郁bZ[W
// ̒l uWMBase𑫂lĂ܂
//---------------------------------------------------------------*/
#define AXCPI01_WM_OFS_CARD_REMOVAL		0	/* J[hbZ[W */
#define AXCPI01_WM_OFS_IN				1	/* O͊荞݃bZ[W */

/*-----------------------------------------------------------------
// \[X\̊evf̍ő吔
//---------------------------------------------------------------*/
#define AXCPI01_MAX_MEM					9
#define AXCPI01_MAX_IO					20
#define AXCPI01_MAX_IRQ					7
#define AXCPI01_MAX_DMA					7

/*-----------------------------------------------------------------
// TvOtB^`
//---------------------------------------------------------------*/
#define AXCPI01_PORT_DATA_L				0x00	/* o̓|[gLow */
#define AXCPI01_PORT_DATA_H				0x01	/* o̓|[gHigh */
#define AXCPI01_PORT_IO_SELECT_L		0x02	/* o͑I|[gLow */
#define AXCPI01_PORT_IO_SELECT_H		0x03	/* o͑I|[gHigh */
#define AXCPI01_PORT_OUTPUT_MODE_L		0x04	/* o̓[hݒ|[gLow */
#define AXCPI01_PORT_OUTPUT_MODE_H		0x05	/* o̓[hݒ|[gHigh */
#define AXCPI01_PORT_PUPD_SELECT_L		0x06	/* PullUp/PullDownI|[gLow */
#define AXCPI01_PORT_PUPD_SELECT_H		0x07	/* PullUp/PullDownI|[gHigh */
#define AXCPI01_PORT_IRQ_L				0x08	/* ݐݒ|[gLow */
#define AXCPI01_PORT_IRQ_H				0x09	/* ݐݒ|[gHigh */


/*-----------------------------------------------------------------
// API Functions
//---------------------------------------------------------------*/
#define AXCPI01_API		extern __declspec( dllimport )

AXCPI01_API BOOL WINAPI Axcpi01GetVersion(PDWORD pdwDllVersion, PDWORD pdwDrvVersion);
AXCPI01_API BOOL WINAPI Axcpi01Create(PWORD pwLogSocket, HWND hWnd, UINT uWMBase, PVOID pvInitArg);
AXCPI01_API BOOL WINAPI Axcpi01Close(WORD wLogSocket);
AXCPI01_API BOOL WINAPI Axcpi01GetResource(WORD wLogSocket, PDWORD pdwIOPortBase, PDWORD pdwIOPortLength);
AXCPI01_API BOOL WINAPI Axcpi01InPortB(WORD wLogSocket, DWORD dwPort, PBYTE pbValue);
AXCPI01_API BOOL WINAPI Axcpi01OutPortB(WORD wLogSocket, DWORD dwPort, BYTE bValue);
AXCPI01_API BOOL WINAPI Axcpi01InPortW(WORD wLogSocket, DWORD dwPort, PWORD pwValue);
AXCPI01_API BOOL WINAPI Axcpi01OutPortW(WORD wLogSocket, DWORD dwPort, WORD wValue);
AXCPI01_API BOOL WINAPI Axcpi01GetIRQStatus(WORD wLogSocket, PBYTE pbStatus);
AXCPI01_API DWORD WINAPI Axcpi01GetLastError(WORD wLogSocket);

#ifdef __cplusplus
}
#endif
#endif
